include:
  - https://gitlab.com/linaro/blueprints/ci/-/raw/main/base.yml


#
#    Build job template
#
.build-meta-ewaol-machine:
  extends: .build
  variables:
    GIT_URL: https://gitlab.com/soafee/ewaol/meta-ewaol-machine.git
    GIT_BRANCH: kirkstone-dev
    TUXSUITE_GROUP: blueprints
    TUXSUITE_PROJECT: ewaol
    SQUAD_GROUP: ewaol
    SQUAD_PROJECT: meta-ewaol-machine-kirkstone-dev


#
#    Build available boards
#
#    - KAS_YAML: parameter given to kas when building locally
#    - IMAGE: target image required to determine if the build was successfull or not. The path is a reference
#             to tuxsuite storage folder of the build
#    - DEVICE: this is mainly used to record this build result in SQUAD, as sort of environment for the build
#
build-meta-ewaol-machine-avadp:
  extends: .build-meta-ewaol-machine
  variables:
    KAS_YAML: kas/ewaol/baremetal.yml:kas/machine/avadp.yml:kas/ewaol/ci-constraints.yml
    IMAGE: baremetal/deploy/images/ava/ewaol-baremetal-image-ava.*.rootfs.wic.bz2
    DEVICE: avadp


#
#    Trigger tests to qemu and real boards
#
#    Further testing will only be triggered upon setting "LAVA_DEVICE" variable, signaling
#    ci scripts to make a test job definition and send it to LAVA, where at least a boot test
#    will take place. By default, ledge.validation.linaro.org is the LAVA instance to run tests.
#
#    - LAVA_DEVICE: specifies a device type that will run tests
#    - FIRMWARE: specifies location of the Firmware that the current build of EWAOL
#          will boot on top of. This can be either a URL or a spec in the format of:
#
#          <job-name>:<firmware-image-path>
#
#          where <job-name> matches the job in https://gitlab.com/linaro/blueprints/ci, and <firmware-image-path>
#          matches the firmware image path existing within the job's artifacts folder.
#
test-meta-ewaol-machine-ledge-security-ava:
  extends: .trigger_tests
  needs:
    - build-meta-ewaol-machine-avadp
  variables:
    FIRMWARE: build-meta-ts-qemuarm64-secureboot:flash.bin-qemu.gz
    LAVA_DEVICE: ava


#
#    Check test runs
#
#    Jobs in this stage ("check_tests") are meant to fetch results from actual test runs
#    causing Gitlab to fail a pipeline if any of the tests run in LAVA fails.
#
check-test-meta-ewaol-machine-ledge-security-ava:
  extends: .check_tests
  needs:
    - test-meta-ewaol-machine-ledge-security-ava
